void LED_ThermalProtection (int critical_temp)
{
  // LED Thermal Protection
  if (radiator_temp >= critical_temp) // if temperature more than 50 degrees
  {
    // we need to turn off LED
    light_state = false;
    digitalWrite(RELAY1, HIGH);
    // And send current led state to blink
    Blynk.virtualWrite(V0, light_state);
  }
}

// Function to control LED Radiator Fan.
// Arguments:
// min_temp - minimum temperature, when we can turn the fan OFF
// max_temp - maximum temperature, when fan turns ON
void FAN_Control(int off_temp, int on_temp)
{
  // another one thermal protection
  if (radiator_temp >= on_temp) // if LED temperature more than 30 degrees
  {
    // We need to turn on fan
    digitalWrite(RADIATOR_FAN, HIGH);
    fan_state = true;
    fan_manual_state = false;
    // Then, send this value to the blink
    Blynk.virtualWrite(V5, fan_state);
  }

  // We can turn fan off, if fan is running now and light turned off (radiator will not heat up again)
  if (radiator_temp < off_temp && fan_state && !light_state && !fan_manual_state)
  {
    // if condition is ok - turn the fan off
    fan_state = false;
    digitalWrite(RADIATOR_FAN, LOW);
    // Then, send this value to the blink
    Blynk.virtualWrite(V5, fan_state);
  }
}

void LED_Processing()
{
  // Lights processing
  if (light_state)
    digitalWrite(RELAY1, LOW);
  else
    digitalWrite(RELAY1, HIGH);
}

void FAN_Processing()
{
  // Fan processing
  if (fan_state)
  {
    digitalWrite(RADIATOR_FAN, HIGH);
    fan_speed = 100;
  }
  else
  {
    digitalWrite(RADIATOR_FAN, LOW);
    fan_speed = 0;
  }
}

void Waterpump_Processing()
{
  if (watering_state)
    digitalWrite(RELAY2, LOW);
  else
    digitalWrite(RELAY2, HIGH);
}
